part of 'generated.dart';

class ListRecentPaymentsByApplicationIdVariablesBuilder {
  String applicationId;
  Optional<int> _offset = Optional.optional(nativeFromJson, nativeToJson);
  Optional<int> _limit = Optional.optional(nativeFromJson, nativeToJson);

  final FirebaseDataConnect _dataConnect;  ListRecentPaymentsByApplicationIdVariablesBuilder offset(int? t) {
   _offset.value = t;
   return this;
  }
  ListRecentPaymentsByApplicationIdVariablesBuilder limit(int? t) {
   _limit.value = t;
   return this;
  }

  ListRecentPaymentsByApplicationIdVariablesBuilder(this._dataConnect, {required  this.applicationId,});
  Deserializer<ListRecentPaymentsByApplicationIdData> dataDeserializer = (dynamic json)  => ListRecentPaymentsByApplicationIdData.fromJson(jsonDecode(json));
  Serializer<ListRecentPaymentsByApplicationIdVariables> varsSerializer = (ListRecentPaymentsByApplicationIdVariables vars) => jsonEncode(vars.toJson());
  Future<QueryResult<ListRecentPaymentsByApplicationIdData, ListRecentPaymentsByApplicationIdVariables>> execute() {
    return ref().execute();
  }

  QueryRef<ListRecentPaymentsByApplicationIdData, ListRecentPaymentsByApplicationIdVariables> ref() {
    ListRecentPaymentsByApplicationIdVariables vars= ListRecentPaymentsByApplicationIdVariables(applicationId: applicationId,offset: _offset,limit: _limit,);
    return _dataConnect.query("listRecentPaymentsByApplicationId", dataDeserializer, varsSerializer, vars);
  }
}

@immutable
class ListRecentPaymentsByApplicationIdRecentPayments {
  final String id;
  final String? workedTime;
  final EnumValue<RecentPaymentStatus>? status;
  final String staffId;
  final String applicationId;
  final String invoiceId;
  final Timestamp? createdAt;
  final Timestamp? updatedAt;
  final String? createdBy;
  final ListRecentPaymentsByApplicationIdRecentPaymentsApplication application;
  final ListRecentPaymentsByApplicationIdRecentPaymentsInvoice invoice;
  ListRecentPaymentsByApplicationIdRecentPayments.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  workedTime = json['workedTime'] == null ? null : nativeFromJson<String>(json['workedTime']),
  status = json['status'] == null ? null : recentPaymentStatusDeserializer(json['status']),
  staffId = nativeFromJson<String>(json['staffId']),
  applicationId = nativeFromJson<String>(json['applicationId']),
  invoiceId = nativeFromJson<String>(json['invoiceId']),
  createdAt = json['createdAt'] == null ? null : Timestamp.fromJson(json['createdAt']),
  updatedAt = json['updatedAt'] == null ? null : Timestamp.fromJson(json['updatedAt']),
  createdBy = json['createdBy'] == null ? null : nativeFromJson<String>(json['createdBy']),
  application = ListRecentPaymentsByApplicationIdRecentPaymentsApplication.fromJson(json['application']),
  invoice = ListRecentPaymentsByApplicationIdRecentPaymentsInvoice.fromJson(json['invoice']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdRecentPayments otherTyped = other as ListRecentPaymentsByApplicationIdRecentPayments;
    return id == otherTyped.id && 
    workedTime == otherTyped.workedTime && 
    status == otherTyped.status && 
    staffId == otherTyped.staffId && 
    applicationId == otherTyped.applicationId && 
    invoiceId == otherTyped.invoiceId && 
    createdAt == otherTyped.createdAt && 
    updatedAt == otherTyped.updatedAt && 
    createdBy == otherTyped.createdBy && 
    application == otherTyped.application && 
    invoice == otherTyped.invoice;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, workedTime.hashCode, status.hashCode, staffId.hashCode, applicationId.hashCode, invoiceId.hashCode, createdAt.hashCode, updatedAt.hashCode, createdBy.hashCode, application.hashCode, invoice.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (workedTime != null) {
      json['workedTime'] = nativeToJson<String?>(workedTime);
    }
    if (status != null) {
      json['status'] = 
    recentPaymentStatusSerializer(status!)
    ;
    }
    json['staffId'] = nativeToJson<String>(staffId);
    json['applicationId'] = nativeToJson<String>(applicationId);
    json['invoiceId'] = nativeToJson<String>(invoiceId);
    if (createdAt != null) {
      json['createdAt'] = createdAt!.toJson();
    }
    if (updatedAt != null) {
      json['updatedAt'] = updatedAt!.toJson();
    }
    if (createdBy != null) {
      json['createdBy'] = nativeToJson<String?>(createdBy);
    }
    json['application'] = application.toJson();
    json['invoice'] = invoice.toJson();
    return json;
  }

  ListRecentPaymentsByApplicationIdRecentPayments({
    required this.id,
    this.workedTime,
    this.status,
    required this.staffId,
    required this.applicationId,
    required this.invoiceId,
    this.createdAt,
    this.updatedAt,
    this.createdBy,
    required this.application,
    required this.invoice,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdRecentPaymentsApplication {
  final String id;
  final EnumValue<ApplicationStatus> status;
  final ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRole shiftRole;
  ListRecentPaymentsByApplicationIdRecentPaymentsApplication.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  status = applicationStatusDeserializer(json['status']),
  shiftRole = ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRole.fromJson(json['shiftRole']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdRecentPaymentsApplication otherTyped = other as ListRecentPaymentsByApplicationIdRecentPaymentsApplication;
    return id == otherTyped.id && 
    status == otherTyped.status && 
    shiftRole == otherTyped.shiftRole;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, status.hashCode, shiftRole.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['status'] = 
    applicationStatusSerializer(status)
    ;
    json['shiftRole'] = shiftRole.toJson();
    return json;
  }

  ListRecentPaymentsByApplicationIdRecentPaymentsApplication({
    required this.id,
    required this.status,
    required this.shiftRole,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRole {
  final double? hours;
  final double? totalValue;
  final ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleRole role;
  final ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleShift shift;
  ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRole.fromJson(dynamic json):
  
  hours = json['hours'] == null ? null : nativeFromJson<double>(json['hours']),
  totalValue = json['totalValue'] == null ? null : nativeFromJson<double>(json['totalValue']),
  role = ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleRole.fromJson(json['role']),
  shift = ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleShift.fromJson(json['shift']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRole otherTyped = other as ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRole;
    return hours == otherTyped.hours && 
    totalValue == otherTyped.totalValue && 
    role == otherTyped.role && 
    shift == otherTyped.shift;
    
  }
  @override
  int get hashCode => Object.hashAll([hours.hashCode, totalValue.hashCode, role.hashCode, shift.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    if (hours != null) {
      json['hours'] = nativeToJson<double?>(hours);
    }
    if (totalValue != null) {
      json['totalValue'] = nativeToJson<double?>(totalValue);
    }
    json['role'] = role.toJson();
    json['shift'] = shift.toJson();
    return json;
  }

  ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRole({
    this.hours,
    this.totalValue,
    required this.role,
    required this.shift,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleRole {
  final String id;
  final String name;
  final double costPerHour;
  ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  name = nativeFromJson<String>(json['name']),
  costPerHour = nativeFromJson<double>(json['costPerHour']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleRole otherTyped = other as ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleRole;
    return id == otherTyped.id && 
    name == otherTyped.name && 
    costPerHour == otherTyped.costPerHour;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, name.hashCode, costPerHour.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['name'] = nativeToJson<String>(name);
    json['costPerHour'] = nativeToJson<double>(costPerHour);
    return json;
  }

  ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleRole({
    required this.id,
    required this.name,
    required this.costPerHour,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleShift {
  final String id;
  final String title;
  final Timestamp? date;
  final String? locationAddress;
  ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleShift.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  title = nativeFromJson<String>(json['title']),
  date = json['date'] == null ? null : Timestamp.fromJson(json['date']),
  locationAddress = json['locationAddress'] == null ? null : nativeFromJson<String>(json['locationAddress']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleShift otherTyped = other as ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleShift;
    return id == otherTyped.id && 
    title == otherTyped.title && 
    date == otherTyped.date && 
    locationAddress == otherTyped.locationAddress;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, title.hashCode, date.hashCode, locationAddress.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['title'] = nativeToJson<String>(title);
    if (date != null) {
      json['date'] = date!.toJson();
    }
    if (locationAddress != null) {
      json['locationAddress'] = nativeToJson<String?>(locationAddress);
    }
    return json;
  }

  ListRecentPaymentsByApplicationIdRecentPaymentsApplicationShiftRoleShift({
    required this.id,
    required this.title,
    this.date,
    this.locationAddress,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdRecentPaymentsInvoice {
  final String id;
  final String invoiceNumber;
  final EnumValue<InvoiceStatus> status;
  final double amount;
  final ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceBusiness business;
  final ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceVendor vendor;
  final ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceOrder order;
  ListRecentPaymentsByApplicationIdRecentPaymentsInvoice.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  invoiceNumber = nativeFromJson<String>(json['invoiceNumber']),
  status = invoiceStatusDeserializer(json['status']),
  amount = nativeFromJson<double>(json['amount']),
  business = ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceBusiness.fromJson(json['business']),
  vendor = ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceVendor.fromJson(json['vendor']),
  order = ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceOrder.fromJson(json['order']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdRecentPaymentsInvoice otherTyped = other as ListRecentPaymentsByApplicationIdRecentPaymentsInvoice;
    return id == otherTyped.id && 
    invoiceNumber == otherTyped.invoiceNumber && 
    status == otherTyped.status && 
    amount == otherTyped.amount && 
    business == otherTyped.business && 
    vendor == otherTyped.vendor && 
    order == otherTyped.order;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, invoiceNumber.hashCode, status.hashCode, amount.hashCode, business.hashCode, vendor.hashCode, order.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['invoiceNumber'] = nativeToJson<String>(invoiceNumber);
    json['status'] = 
    invoiceStatusSerializer(status)
    ;
    json['amount'] = nativeToJson<double>(amount);
    json['business'] = business.toJson();
    json['vendor'] = vendor.toJson();
    json['order'] = order.toJson();
    return json;
  }

  ListRecentPaymentsByApplicationIdRecentPaymentsInvoice({
    required this.id,
    required this.invoiceNumber,
    required this.status,
    required this.amount,
    required this.business,
    required this.vendor,
    required this.order,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceBusiness {
  final String id;
  final String businessName;
  ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceBusiness.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  businessName = nativeFromJson<String>(json['businessName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceBusiness otherTyped = other as ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceBusiness;
    return id == otherTyped.id && 
    businessName == otherTyped.businessName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, businessName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['businessName'] = nativeToJson<String>(businessName);
    return json;
  }

  ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceBusiness({
    required this.id,
    required this.businessName,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceVendor {
  final String id;
  final String companyName;
  ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceVendor.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  companyName = nativeFromJson<String>(json['companyName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceVendor otherTyped = other as ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceVendor;
    return id == otherTyped.id && 
    companyName == otherTyped.companyName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, companyName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['companyName'] = nativeToJson<String>(companyName);
    return json;
  }

  ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceVendor({
    required this.id,
    required this.companyName,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceOrder {
  final String id;
  final String? eventName;
  final String? location;
  ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceOrder.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  eventName = json['eventName'] == null ? null : nativeFromJson<String>(json['eventName']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceOrder otherTyped = other as ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceOrder;
    return id == otherTyped.id && 
    eventName == otherTyped.eventName && 
    location == otherTyped.location;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, eventName.hashCode, location.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (eventName != null) {
      json['eventName'] = nativeToJson<String?>(eventName);
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    return json;
  }

  ListRecentPaymentsByApplicationIdRecentPaymentsInvoiceOrder({
    required this.id,
    this.eventName,
    this.location,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdData {
  final List<ListRecentPaymentsByApplicationIdRecentPayments> recentPayments;
  ListRecentPaymentsByApplicationIdData.fromJson(dynamic json):
  
  recentPayments = (json['recentPayments'] as List<dynamic>)
        .map((e) => ListRecentPaymentsByApplicationIdRecentPayments.fromJson(e))
        .toList();
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdData otherTyped = other as ListRecentPaymentsByApplicationIdData;
    return recentPayments == otherTyped.recentPayments;
    
  }
  @override
  int get hashCode => recentPayments.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['recentPayments'] = recentPayments.map((e) => e.toJson()).toList();
    return json;
  }

  ListRecentPaymentsByApplicationIdData({
    required this.recentPayments,
  });
}

@immutable
class ListRecentPaymentsByApplicationIdVariables {
  final String applicationId;
  late final Optional<int>offset;
  late final Optional<int>limit;
  @Deprecated('fromJson is deprecated for Variable classes as they are no longer required for deserialization.')
  ListRecentPaymentsByApplicationIdVariables.fromJson(Map<String, dynamic> json):
  
  applicationId = nativeFromJson<String>(json['applicationId']) {
  
  
  
    offset = Optional.optional(nativeFromJson, nativeToJson);
    offset.value = json['offset'] == null ? null : nativeFromJson<int>(json['offset']);
  
  
    limit = Optional.optional(nativeFromJson, nativeToJson);
    limit.value = json['limit'] == null ? null : nativeFromJson<int>(json['limit']);
  
  }
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByApplicationIdVariables otherTyped = other as ListRecentPaymentsByApplicationIdVariables;
    return applicationId == otherTyped.applicationId && 
    offset == otherTyped.offset && 
    limit == otherTyped.limit;
    
  }
  @override
  int get hashCode => Object.hashAll([applicationId.hashCode, offset.hashCode, limit.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['applicationId'] = nativeToJson<String>(applicationId);
    if(offset.state == OptionalState.set) {
      json['offset'] = offset.toJson();
    }
    if(limit.state == OptionalState.set) {
      json['limit'] = limit.toJson();
    }
    return json;
  }

  ListRecentPaymentsByApplicationIdVariables({
    required this.applicationId,
    required this.offset,
    required this.limit,
  });
}

